Index: /trunk/src/emx/include/emx/io.h
===================================================================
--- /trunk/src/emx/include/emx/io.h	(revision 1749)
+++ /trunk/src/emx/include/emx/io.h	(revision 1750)
@@ -373,4 +373,12 @@
     __LIBC_PCFHOPS          pOps;
 
+    /** Device number of the device containing the file.
+     * The device number is also determined from the path, more correctly the
+     * driveletter determins this. */
+    dev_t                   Dev;
+    /** Inode number of the file.
+     * Since the inode number is usually calculated from the path we need to
+     * determin this at handle creation time. */
+    ino_t                   Inode;
 } __LIBC_FH;
 /** Pointer to filehandle. */
Index: /trunk/src/emx/src/lib/sys/__dup.c
===================================================================
--- /trunk/src/emx/src/lib/sys/__dup.c	(revision 1749)
+++ /trunk/src/emx/src/lib/sys/__dup.c	(revision 1750)
@@ -57,4 +57,6 @@
                 pFHNew->fFlags      = pFH->fFlags;
                 pFHNew->iLookAhead  = pFH->iLookAhead;
+                pFHNew->Inode       = pFH->Inode;
+                pFHNew->Dev         = pFH->Dev;
             }
             else
Index: /trunk/src/emx/src/lib/sys/__dup2.c
===================================================================
--- /trunk/src/emx/src/lib/sys/__dup2.c	(revision 1749)
+++ /trunk/src/emx/src/lib/sys/__dup2.c	(revision 1750)
@@ -90,4 +90,6 @@
                 pFHNew->fFlags      = pFH->fFlags;
                 pFHNew->iLookAhead  = pFH->iLookAhead;
+                pFHNew->Inode       = pFH->Inode;
+                pFHNew->Dev         = pFH->Dev;
             }
             else
Index: /trunk/src/emx/src/lib/sys/b_fs.h
===================================================================
--- /trunk/src/emx/src/lib/sys/b_fs.h	(revision 1749)
+++ /trunk/src/emx/src/lib/sys/b_fs.h	(revision 1750)
@@ -31,4 +31,5 @@
 #include <sys/syslimits.h>
 #include <sys/types.h>
+#include <emx/io.h>
 #include <InnoTekLIBC/sharedpm.h>
 #include "backend.h"
@@ -136,13 +137,15 @@
 /**
  * Creates the unix EAs for a new file or directory.
+ *
  * @returns 0 on success.
  * @returns Negative errno on failure.
  * @param   hFile           File handle to the newly created fs object. If no
  *                          handle handy, set to -1.
- * @param   pszNativePath   Native path of the newly created fs object. If
- *                          handle is give this will be ignored.
+ * @param   pszNativePath   Native path to the newly created fs object.
  * @param   mode            The specified file permission mode mask.
- */
-int __libc_back_fsUnixAttribsSet(int hFile, const char *pszNativePath, mode_t mode);
+ * @param   pDev            Where to store the dev number.
+ * @param   pInode          Where to store the calculated inode number.
+ */
+int __libc_back_fsUnixAttribsSet(int hFile, const char *pszNativePath, mode_t mode, dev_t *pDev, ino_t *pInode);
 
 /**
@@ -197,4 +200,15 @@
 int __libc_back_fsNativeFileStat(const char *pszNativePath, struct stat *pStat);
 
+/**
+ * Calc the Inode and Dev based on native path.
+ *
+ * @returns device number and *pInode.
+ *
+ * @param   pszNativePath       Pointer to native path.
+ * @param   pInode              Where to store the inode number.
+ * @remark  This doesn't work right when in non-unix mode!
+ */
+dev_t __libc_back_fsPathCalcInodeAndDev(const char *pszNativePath, ino_t *pInode);
+
 
 __END_DECLS
Index: /trunk/src/emx/src/lib/sys/b_fsDirCreate.c
===================================================================
--- /trunk/src/emx/src/lib/sys/b_fsDirCreate.c	(revision 1749)
+++ /trunk/src/emx/src/lib/sys/b_fsDirCreate.c	(revision 1750)
@@ -71,5 +71,5 @@
     if (!rc)
     {
-        __libc_back_fsUnixAttribsSet(-1, &szNativePath[0], Mode);
+        __libc_back_fsUnixAttribsSet(-1, &szNativePath[0], Mode, NULL, NULL);
         LIBCLOG_RETURN_INT(0);
     }
Index: /trunk/src/emx/src/lib/sys/b_fsFileStatFH.c
===================================================================
--- /trunk/src/emx/src/lib/sys/b_fsFileStatFH.c	(revision 1749)
+++ /trunk/src/emx/src/lib/sys/b_fsFileStatFH.c	(revision 1750)
@@ -93,8 +93,6 @@
         pStat->st_uid = 0;
         pStat->st_gid = 0;
-        pStat->st_ino = _sys_ino++;
-        if (_sys_ino == 0)
-            _sys_ino = 1;
-        pStat->st_dev = 0;
+        pStat->st_ino = pFH->Inode;
+        pStat->st_dev = pFH->Dev;
         pStat->st_rdev = 0;
         pStat->st_nlink = 1;
Index: /trunk/src/emx/src/lib/sys/b_fsNativeFileStat.c
===================================================================
--- /trunk/src/emx/src/lib/sys/b_fsNativeFileStat.c	(revision 1749)
+++ /trunk/src/emx/src/lib/sys/b_fsNativeFileStat.c	(revision 1750)
@@ -188,8 +188,5 @@
     pStat->st_uid = 0;
     pStat->st_gid = 0;
-    pStat->st_ino = _sys_ino++;
-    if (_sys_ino == 0)
-        _sys_ino = 1;
-    pStat->st_dev = 0;
+    pStat->st_dev = __libc_back_fsPathCalcInodeAndDev(pszNativePath, &pStat->st_ino);
     pStat->st_rdev = 0;
     pStat->st_nlink = 1;
Index: /trunk/src/emx/src/lib/sys/b_ioFileOpen.c
===================================================================
--- /trunk/src/emx/src/lib/sys/b_ioFileOpen.c	(revision 1749)
+++ /trunk/src/emx/src/lib/sys/b_ioFileOpen.c	(revision 1750)
@@ -174,4 +174,6 @@
         ULONG   fulType;
         ULONG   fulDevFlags;
+        dev_t   Dev;
+        ino_t   Inode;
 
         /*
@@ -180,5 +182,8 @@
         if (   (ulAction == FILE_CREATED)
             && !__libc_gfNoUnix)
-            __libc_back_fsUnixAttribsSet(hFile, NULL, Mode);
+            __libc_back_fsUnixAttribsSet(hFile, pszFile, Mode, &Dev, &Inode);
+        else
+            Dev = __libc_back_fsPathCalcInodeAndDev(szNativePath, &(*ppFH)->Inode);
+
 
         /*
@@ -203,9 +208,18 @@
 
             /*
-             * Register the handle.
+             * Register the handle and calc Dev and Inode.
+             * We calc the Dev/Inode regardless of whether it's stored in an EA or not.
              */
             rc = __libc_FHAllocate(hFile, fLibc, sizeof(LIBCFH), NULL, ppFH, NULL);
-            LIBCLOG_MSG("hFile=%#lx fLibc=%#x fulType=%#lx ulAction=%lu\n",
-                        hFile, fLibc, fulType, ulAction);
+            if (!rc)
+            {
+                if (ppFH)
+                {
+                    (*ppFH)->Dev = Dev;
+                    (*ppFH)->Inode = Inode;
+                }
+                LIBCLOG_MSG("hFile=%#lx fLibc=%#x fulType=%#lx ulAction=%lu Dev=%#x Inode=%#llx\n",
+                            hFile, fLibc, fulType, ulAction, Dev, Inode);
+            }
         }
 
Index: /trunk/src/emx/src/lib/sys/filehandles.c
===================================================================
--- /trunk/src/emx/src/lib/sys/filehandles.c	(revision 1749)
+++ /trunk/src/emx/src/lib/sys/filehandles.c	(revision 1750)
@@ -735,4 +735,8 @@
         pFH->iLookAhead = -1;
         pFH->pOps       = pOps;
+        pFH->Inode      = ++_sys_ino;
+        if (!pFH->Inode)
+            pFH->Inode  = ++_sys_ino;
+        pFH->Dev        = 0;
 
         /*
Index: /trunk/src/emx/src/lib/sys/fs.c
===================================================================
--- /trunk/src/emx/src/lib/sys/fs.c	(revision 1749)
+++ /trunk/src/emx/src/lib/sys/fs.c	(revision 1750)
@@ -187,4 +187,7 @@
 *******************************************************************************/
 static int fsResolveUnix(const char *pszUserPath, unsigned fFlags, char *pszNativePath, int *pfInUnixTree);
+static uint32_t crc32str(const char *psz);
+static uint32_t djb2(const char *str);
+static uint32_t sdbm(const char *str);
 
 
@@ -1234,17 +1237,50 @@
 /**
  * Creates the unix EAs for a new file or directory.
+ *
  * @returns 0 on success.
  * @returns Negative errno on failure.
  * @param   hFile           File handle to the newly created fs object. If no
  *                          handle handy, set to -1.
- * @param   pszNativePath   Native path to the newly created fs object. If
- *                          handle is give this will be ignored.
+ * @param   pszNativePath   Native path to the newly created fs object.
  * @param   mode            The specified file permission mode mask.
+ * @param   pDev            Where to store the dev number.
+ * @param   pInode          Where to store the calculated inode number.
  */
-int __libc_back_fsUnixAttribsSet(int hFile, const char *pszNativePath, mode_t mode)
-{
-    /* later */
+int __libc_back_fsUnixAttribsSet(int hFile, const char *pszNativePath, mode_t mode, dev_t *pDev, ino_t *pInode)
+{
+    /*
+     * Calc device.
+     */
+    dev_t   Dev;
+    char    chDrv = *pszNativePath;
+    if (chDrv == '/' || chDrv == '\\')
+        Dev = makedev('U', 0);          /* U as in UNC */
+    else
+    {
+        /* ASSUMES that pszNativePath contains a driveletter! If not fix the resolver!!! */
+        if (chDrv >= 'a' && chDrv <= 'z')
+            chDrv -= 'a' - 'A';
+        Dev = makedev('V', chDrv);      /* V as in Volume */
+    }
+
+    /*
+     * Calc Inode number.
+     *
+     * Whether to use another hash algorithm here is a bit in the blue now
+     * because the stored value might be inaccessible at times.
+     */
+    const char *psz = pszNativePath;
+    if (psz[1] == ':')
+        psz += 2;
+    ino_t Inode = ((uint64_t)crc32str(psz) << 32) | (uint64_t)djb2(psz);
+
+    /** @todo Save unix EAs! */
+    if (pDev)
+        *pDev = Dev;
+    if (pInode)
+        *pInode = (Inode & 0xffffffff00000000ULL) | (uint64_t)sdbm(psz);
     return 0;
 }
+
 
 /**
@@ -1339,2 +1375,188 @@
 
 
+/**
+ * Calc the Inode and Dev based on native path.
+ *
+ * @returns device number and *pInode.
+ *
+ * @param   pszNativePath       Pointer to native path.
+ * @param   pInode              Where to store the inode number.
+ * @remark  This doesn't work right when in non-unix mode!
+ */
+dev_t __libc_back_fsPathCalcInodeAndDev(const char *pszNativePath, ino_t *pInode)
+{
+    /*
+     * Calc device.
+     */
+    dev_t   Dev;
+    char    chDrv = *pszNativePath;
+    if (chDrv == '/' || chDrv == '\\')
+        Dev = makedev('U', 0);          /* U as in UNC */
+    else
+    {
+        /* ASSUMES that pszNativePath contains a driveletter! If not fix the resolver!!! */
+        if (chDrv >= 'a' && chDrv <= 'z')
+            chDrv -= 'a' - 'A';
+        Dev = makedev('V', chDrv);      /* V as in Volume */
+    }
+
+    /*
+     * Calc Inode number.
+     */
+    const char *psz = pszNativePath;
+    if (psz[1] == ':')
+        psz += 2;
+    *pInode = ((uint64_t)crc32str(psz) << 32) | (uint64_t)sdbm(psz);
+    return Dev;
+}
+
+
+/* djb2:
+  This algorithm (k=33) was first reported by dan bernstein many years ago in
+  comp.lang.c. Another version of this algorithm (now favored by bernstein) uses
+  xor: hash(i) = hash(i - 1) * 33 ^ str[i]; the magic of number 33 (why it
+  works better than many other constants, prime or not) has never been
+  adequately explained. */
+
+static uint32_t djb2(const char *str)
+{
+    uint32_t hash = 5381;
+    int c;
+
+    while ((c = *(unsigned const char *)str++))
+        hash = ((hash << 5) + hash) + c; /* hash * 33 + c */
+
+    return hash;
+}
+
+/* sdbm:
+   This algorithm was created for sdbm (a public-domain reimplementation of
+   ndbm) database library. it was found to do well in scrambling bits,
+   causing better distribution of the keys and fewer splits. it also happens
+   to be a good general hashing function with good distribution. the actual
+   function is hash(i) = hash(i - 1) * 65599 + str[i]; what is included below
+   is the faster version used in gawk. [there is even a faster, duff-device
+   version] the magic constant 65599 was picked out of thin air while
+   experimenting with different constants, and turns out to be a prime.
+   this is one of the algorithms used in berkeley db (see sleepycat) and
+   elsewhere. */
+static uint32_t sdbm(const char *str)
+{
+    uint32_t hash = 0;
+    int c;
+
+    while ((c = *(unsigned const char *)str++))
+        hash = c + (hash << 6) + (hash << 16) - hash;
+
+    return hash;
+}
+
+/*-
+ *  COPYRIGHT (C) 1986 Gary S. Brown.  You may use this program, or
+ *  code or tables extracted from it, as desired without restriction.
+ *
+ *  First, the polynomial itself and its table of feedback terms.  The
+ *  polynomial is
+ *  X^32+X^26+X^23+X^22+X^16+X^12+X^11+X^10+X^8+X^7+X^5+X^4+X^2+X^1+X^0
+ *
+ *  Note that we take it "backwards" and put the highest-order term in
+ *  the lowest-order bit.  The X^32 term is "implied"; the LSB is the
+ *  X^31 term, etc.  The X^0 term (usually shown as "+1") results in
+ *  the MSB being 1
+ *
+ *  Note that the usual hardware shift register implementation, which
+ *  is what we're using (we're merely optimizing it by doing eight-bit
+ *  chunks at a time) shifts bits into the lowest-order term.  In our
+ *  implementation, that means shifting towards the right.  Why do we
+ *  do it this way?  Because the calculated CRC must be transmitted in
+ *  order from highest-order term to lowest-order term.  UARTs transmit
+ *  characters in order from LSB to MSB.  By storing the CRC this way
+ *  we hand it to the UART in the order low-byte to high-byte; the UART
+ *  sends each low-bit to hight-bit; and the result is transmission bit
+ *  by bit from highest- to lowest-order term without requiring any bit
+ *  shuffling on our part.  Reception works similarly
+ *
+ *  The feedback terms table consists of 256, 32-bit entries.  Notes
+ *
+ *      The table can be generated at runtime if desired; code to do so
+ *      is shown later.  It might not be obvious, but the feedback
+ *      terms simply represent the results of eight shift/xor opera
+ *      tions for all combinations of data and CRC register values
+ *
+ *      The values must be right-shifted by eight bits by the "updcrc
+ *      logic; the shift must be unsigned (bring in zeroes).  On some
+ *      hardware you could probably optimize the shift in assembler by
+ *      using byte-swap instructions
+ *      polynomial $edb88320
+ *
+ *
+ * CRC32 code derived from work by Gary S. Brown.
+ */
+
+#include <sys/cdefs.h>
+__FBSDID("$FreeBSD: src/sys/libkern/crc32.c,v 1.2 2003/06/11 05:23:04 obrien Exp $");
+
+#include <sys/param.h>
+/* #include <sys/systm.h> */
+
+static const uint32_t crc32_tab[] = {
+	0x00000000, 0x77073096, 0xee0e612c, 0x990951ba, 0x076dc419, 0x706af48f,
+	0xe963a535, 0x9e6495a3,	0x0edb8832, 0x79dcb8a4, 0xe0d5e91e, 0x97d2d988,
+	0x09b64c2b, 0x7eb17cbd, 0xe7b82d07, 0x90bf1d91, 0x1db71064, 0x6ab020f2,
+	0xf3b97148, 0x84be41de,	0x1adad47d, 0x6ddde4eb, 0xf4d4b551, 0x83d385c7,
+	0x136c9856, 0x646ba8c0, 0xfd62f97a, 0x8a65c9ec,	0x14015c4f, 0x63066cd9,
+	0xfa0f3d63, 0x8d080df5,	0x3b6e20c8, 0x4c69105e, 0xd56041e4, 0xa2677172,
+	0x3c03e4d1, 0x4b04d447, 0xd20d85fd, 0xa50ab56b,	0x35b5a8fa, 0x42b2986c,
+	0xdbbbc9d6, 0xacbcf940,	0x32d86ce3, 0x45df5c75, 0xdcd60dcf, 0xabd13d59,
+	0x26d930ac, 0x51de003a, 0xc8d75180, 0xbfd06116, 0x21b4f4b5, 0x56b3c423,
+	0xcfba9599, 0xb8bda50f, 0x2802b89e, 0x5f058808, 0xc60cd9b2, 0xb10be924,
+	0x2f6f7c87, 0x58684c11, 0xc1611dab, 0xb6662d3d,	0x76dc4190, 0x01db7106,
+	0x98d220bc, 0xefd5102a, 0x71b18589, 0x06b6b51f, 0x9fbfe4a5, 0xe8b8d433,
+	0x7807c9a2, 0x0f00f934, 0x9609a88e, 0xe10e9818, 0x7f6a0dbb, 0x086d3d2d,
+	0x91646c97, 0xe6635c01, 0x6b6b51f4, 0x1c6c6162, 0x856530d8, 0xf262004e,
+	0x6c0695ed, 0x1b01a57b, 0x8208f4c1, 0xf50fc457, 0x65b0d9c6, 0x12b7e950,
+	0x8bbeb8ea, 0xfcb9887c, 0x62dd1ddf, 0x15da2d49, 0x8cd37cf3, 0xfbd44c65,
+	0x4db26158, 0x3ab551ce, 0xa3bc0074, 0xd4bb30e2, 0x4adfa541, 0x3dd895d7,
+	0xa4d1c46d, 0xd3d6f4fb, 0x4369e96a, 0x346ed9fc, 0xad678846, 0xda60b8d0,
+	0x44042d73, 0x33031de5, 0xaa0a4c5f, 0xdd0d7cc9, 0x5005713c, 0x270241aa,
+	0xbe0b1010, 0xc90c2086, 0x5768b525, 0x206f85b3, 0xb966d409, 0xce61e49f,
+	0x5edef90e, 0x29d9c998, 0xb0d09822, 0xc7d7a8b4, 0x59b33d17, 0x2eb40d81,
+	0xb7bd5c3b, 0xc0ba6cad, 0xedb88320, 0x9abfb3b6, 0x03b6e20c, 0x74b1d29a,
+	0xead54739, 0x9dd277af, 0x04db2615, 0x73dc1683, 0xe3630b12, 0x94643b84,
+	0x0d6d6a3e, 0x7a6a5aa8, 0xe40ecf0b, 0x9309ff9d, 0x0a00ae27, 0x7d079eb1,
+	0xf00f9344, 0x8708a3d2, 0x1e01f268, 0x6906c2fe, 0xf762575d, 0x806567cb,
+	0x196c3671, 0x6e6b06e7, 0xfed41b76, 0x89d32be0, 0x10da7a5a, 0x67dd4acc,
+	0xf9b9df6f, 0x8ebeeff9, 0x17b7be43, 0x60b08ed5, 0xd6d6a3e8, 0xa1d1937e,
+	0x38d8c2c4, 0x4fdff252, 0xd1bb67f1, 0xa6bc5767, 0x3fb506dd, 0x48b2364b,
+	0xd80d2bda, 0xaf0a1b4c, 0x36034af6, 0x41047a60, 0xdf60efc3, 0xa867df55,
+	0x316e8eef, 0x4669be79, 0xcb61b38c, 0xbc66831a, 0x256fd2a0, 0x5268e236,
+	0xcc0c7795, 0xbb0b4703, 0x220216b9, 0x5505262f, 0xc5ba3bbe, 0xb2bd0b28,
+	0x2bb45a92, 0x5cb36a04, 0xc2d7ffa7, 0xb5d0cf31, 0x2cd99e8b, 0x5bdeae1d,
+	0x9b64c2b0, 0xec63f226, 0x756aa39c, 0x026d930a, 0x9c0906a9, 0xeb0e363f,
+	0x72076785, 0x05005713, 0x95bf4a82, 0xe2b87a14, 0x7bb12bae, 0x0cb61b38,
+	0x92d28e9b, 0xe5d5be0d, 0x7cdcefb7, 0x0bdbdf21, 0x86d3d2d4, 0xf1d4e242,
+	0x68ddb3f8, 0x1fda836e, 0x81be16cd, 0xf6b9265b, 0x6fb077e1, 0x18b74777,
+	0x88085ae6, 0xff0f6a70, 0x66063bca, 0x11010b5c, 0x8f659eff, 0xf862ae69,
+	0x616bffd3, 0x166ccf45, 0xa00ae278, 0xd70dd2ee, 0x4e048354, 0x3903b3c2,
+	0xa7672661, 0xd06016f7, 0x4969474d, 0x3e6e77db, 0xaed16a4a, 0xd9d65adc,
+	0x40df0b66, 0x37d83bf0, 0xa9bcae53, 0xdebb9ec5, 0x47b2cf7f, 0x30b5ffe9,
+	0xbdbdf21c, 0xcabac28a, 0x53b39330, 0x24b4a3a6, 0xbad03605, 0xcdd70693,
+	0x54de5729, 0x23d967bf, 0xb3667a2e, 0xc4614ab8, 0x5d681b02, 0x2a6f2b94,
+	0xb40bbe37, 0xc30c8ea1, 0x5a05df1b, 0x2d02ef8d
+};
+
+static uint32_t
+crc32str(const char *psz)
+{
+	const uint8_t *p;
+	uint32_t crc;
+
+	p = (const uint8_t *)psz;
+	crc = ~0U;
+
+	while (*p)
+		crc = crc32_tab[(crc ^ *p++) & 0xFF] ^ (crc >> 8);
+
+	return crc ^ ~0U;
+}
+