Index: trunk/kBuild/units/qt3.kmk
===================================================================
--- trunk/kBuild/units/qt3.kmk	(revision 1760)
+++ trunk/kBuild/units/qt3.kmk	(revision 1761)
@@ -675,20 +675,20 @@
 # Deal with QT_MODULES and QT_PREFIX.
 local qt_prefix := $(firstword \
-	$($(target)_QT_PREFIX.$(_bld_trg)) \
- 	$($(target)_QT_PREFIX.$(_bld_trg_arch)) \
- 	$($(target)_QT_PREFIX.$(_bld_trg).$(_bld_trg_arch)) \
- 	$($(target)_QT_PREFIX.$(_bld_trg_cpu)) \
- 	$($(target)_QT_PREFIX.$(_bld_type)) \
+	$($(target)_QT_PREFIX.$(bld_trg)) \
+ 	$($(target)_QT_PREFIX.$(bld_trg_arch)) \
+ 	$($(target)_QT_PREFIX.$(bld_trg).$(bld_trg_arch)) \
+ 	$($(target)_QT_PREFIX.$(bld_trg_cpu)) \
+ 	$($(target)_QT_PREFIX.$(bld_type)) \
  	$($(target)_QT_PREFIX))
 ifeq ($(bld_trg),win)
  local qt_lib := $(firstword $(wildcard \
-	$(PATH_SDK_QT3_LIB)/dynamic/$(qt_prefix)qt-mt3$(SUFF_LIB) \
-	$(PATH_SDK_QT3_LIB)/$(qt_prefix)qt-mt3$(SUFF_LIB) \
+	$(PATH_SDK_QT3_LIB)/dynamic/$(qt_prefix)qt-mt3*$(SUFF_LIB) \
+	$(PATH_SDK_QT3_LIB)/$(qt_prefix)qt-mt3*$(SUFF_LIB) \
 	$(PATH_SDK_QT3_LIB)/dynamic/$(qt_prefix)qt-mt$(SUFF_LIB) \
 	$(PATH_SDK_QT3_LIB)/$(qt_prefix)qt-mt$(SUFF_LIB) \
-	$(PATH_SDK_QT3_LIB)/dynamic/$(qt_prefix)Qt3$(SUFF_LIB) \
-	$(PATH_SDK_QT3_LIB)/$(qt_prefix)Qt3$(SUFF_LIB) \
-	$(PATH_SDK_QT3_LIB)/dynamic/$(qt_prefix)Qt$(SUFF_LIB) \
-	$(PATH_SDK_QT3_LIB)/$(qt_prefix)Qt$(SUFF_LIB) \
+	$(PATH_SDK_QT3_LIB)/dynamic/$(qt_prefix)Qt3*$(SUFF_LIB) \
+	$(PATH_SDK_QT3_LIB)/$(qt_prefix)Qt3*$(SUFF_LIB) \
+	$(PATH_SDK_QT3_LIB)/dynamic/$(qt_prefix)Qt*$(SUFF_LIB) \
+	$(PATH_SDK_QT3_LIB)/$(qt_prefix)Qt*$(SUFF_LIB) \
 	) $(PATH_SDK_QT3_LIB)/$(qt_prefix)qt-mt$(SUFF_LIB) )
  $(eval $(target)_LIBS    += $(qt_lib) )
@@ -709,9 +709,9 @@
 ifndef $(target)_QT_MOCSRCS
  $(foreach source, $(filter %.cxx %.CXX %.cpp %.CPP %.cc %.CC,\
- 	$($(target)_SOURCES.$(_bld_trg)) \
- 	$($(target)_SOURCES.$(_bld_trg_arch)) \
- 	$($(target)_SOURCES.$(_bld_trg).$(_bld_trg_arch)) \
- 	$($(target)_SOURCES.$(_bld_trg_cpu)) \
- 	$($(target)_SOURCES.$(_bld_type)) \
+ 	$($(target)_SOURCES.$(bld_trg)) \
+ 	$($(target)_SOURCES.$(bld_trg_arch)) \
+ 	$($(target)_SOURCES.$(bld_trg).$(bld_trg_arch)) \
+ 	$($(target)_SOURCES.$(bld_trg_cpu)) \
+ 	$($(target)_SOURCES.$(bld_type)) \
  	$($(target)_SOURCES) \
  	), $(evalval def_unit_qt3_target_pre_cpp_source))
@@ -732,9 +732,9 @@
 # Calc .ui sources so we can add them to the QT_MOCSRCS and QT_MOCHDRS.
 local ui_sources := $(notdir $(basename $(filter %.ui %.UI, \
-	$($(target)_SOURCES.$(_bld_trg)) \
- 	$($(target)_SOURCES.$(_bld_trg_arch)) \
- 	$($(target)_SOURCES.$(_bld_trg).$(_bld_trg_arch)) \
- 	$($(target)_SOURCES.$(_bld_trg_cpu)) \
- 	$($(target)_SOURCES.$(_bld_type)) \
+	$($(target)_SOURCES.$(bld_trg)) \
+ 	$($(target)_SOURCES.$(bld_trg_arch)) \
+ 	$($(target)_SOURCES.$(bld_trg).$(bld_trg_arch)) \
+ 	$($(target)_SOURCES.$(bld_trg_cpu)) \
+ 	$($(target)_SOURCES.$(bld_type)) \
  	$($(target)_SOURCES) \
 	)))
@@ -743,9 +743,9 @@
 # Deal with QT_MOCSRCS.
 $(foreach source, \
-	$($(target)_QT_MOCSRCS.$(_bld_trg)) \
- 	$($(target)_QT_MOCSRCS.$(_bld_trg_arch)) \
- 	$($(target)_QT_MOCSRCS.$(_bld_trg).$(_bld_trg_arch)) \
- 	$($(target)_QT_MOCSRCS.$(_bld_trg_cpu)) \
- 	$($(target)_QT_MOCSRCS.$(_bld_type)) \
+	$($(target)_QT_MOCSRCS.$(bld_trg)) \
+ 	$($(target)_QT_MOCSRCS.$(bld_trg_arch)) \
+ 	$($(target)_QT_MOCSRCS.$(bld_trg).$(bld_trg_arch)) \
+ 	$($(target)_QT_MOCSRCS.$(bld_trg_cpu)) \
+ 	$($(target)_QT_MOCSRCS.$(bld_type)) \
  	$($(target)_QT_MOCSRCS) \
 	$(addsuffix .h,$(addprefix $(qtuicdir)/,$(notdir $(basename $(ui_sources))))) \
@@ -754,9 +754,9 @@
 # Deal with QT_MOCHDRS.
 $(foreach source, \
-	$($(target)_QT_MOCHDRS.$(_bld_trg)) \
- 	$($(target)_QT_MOCHDRS.$(_bld_trg_arch)) \
- 	$($(target)_QT_MOCHDRS.$(_bld_trg).$(_bld_trg_arch)) \
- 	$($(target)_QT_MOCHDRS.$(_bld_trg_cpu)) \
- 	$($(target)_QT_MOCHDRS.$(_bld_type)) \
+	$($(target)_QT_MOCHDRS.$(bld_trg)) \
+ 	$($(target)_QT_MOCHDRS.$(bld_trg_arch)) \
+ 	$($(target)_QT_MOCHDRS.$(bld_trg).$(bld_trg_arch)) \
+ 	$($(target)_QT_MOCHDRS.$(bld_trg_cpu)) \
+ 	$($(target)_QT_MOCHDRS.$(bld_type)) \
  	$($(target)_QT_MOCHDRS) \
 	$(addsuffix .h,$(addprefix $(qtuicdir)/,$(notdir $(basename $(ui_sources))))) \
@@ -766,9 +766,9 @@
 # ASSUMES (_ALL_)INSTALLS is processed after the targets using this unit.
 local translations := \
-	$($(target)_QT_TRANSLATIONS.$(_bld_trg)) \
- 	$($(target)_QT_TRANSLATIONS.$(_bld_trg_arch)) \
- 	$($(target)_QT_TRANSLATIONS.$(_bld_trg).$(_bld_trg_arch)) \
- 	$($(target)_QT_TRANSLATIONS.$(_bld_trg_cpu)) \
- 	$($(target)_QT_TRANSLATIONS.$(_bld_type)) \
+	$($(target)_QT_TRANSLATIONS.$(bld_trg)) \
+ 	$($(target)_QT_TRANSLATIONS.$(bld_trg_arch)) \
+ 	$($(target)_QT_TRANSLATIONS.$(bld_trg).$(bld_trg_arch)) \
+ 	$($(target)_QT_TRANSLATIONS.$(bld_trg_cpu)) \
+ 	$($(target)_QT_TRANSLATIONS.$(bld_type)) \
  	$($(target)_QT_TRANSLATIONS)
 ifneq ($(strip $(translations)),)
Index: trunk/kBuild/units/qt4.kmk
===================================================================
--- trunk/kBuild/units/qt4.kmk	(revision 1760)
+++ trunk/kBuild/units/qt4.kmk	(revision 1761)
@@ -799,16 +799,16 @@
 # Deal with QT_MODULES and QT_PREFIX.
 local qt_modules := \
-	$($(target)_QT_MODULES.$(_bld_trg)) \
- 	$($(target)_QT_MODULES.$(_bld_trg_arch)) \
- 	$($(target)_QT_MODULES.$(_bld_trg).$(_bld_trg_arch)) \
- 	$($(target)_QT_MODULES.$(_bld_trg_cpu)) \
- 	$($(target)_QT_MODULES.$(_bld_type)) \
+	$($(target)_QT_MODULES.$(bld_trg)) \
+ 	$($(target)_QT_MODULES.$(bld_trg_arch)) \
+ 	$($(target)_QT_MODULES.$(bld_trg).$(bld_trg_arch)) \
+ 	$($(target)_QT_MODULES.$(bld_trg_cpu)) \
+ 	$($(target)_QT_MODULES.$(bld_type)) \
  	$($(target)_QT_MODULES)
 local qt_prefix := $(firstword \
-	$($(target)_QT_PREFIX.$(_bld_trg)) \
- 	$($(target)_QT_PREFIX.$(_bld_trg_arch)) \
- 	$($(target)_QT_PREFIX.$(_bld_trg).$(_bld_trg_arch)) \
- 	$($(target)_QT_PREFIX.$(_bld_trg_cpu)) \
- 	$($(target)_QT_PREFIX.$(_bld_type)) \
+	$($(target)_QT_PREFIX.$(bld_trg)) \
+ 	$($(target)_QT_PREFIX.$(bld_trg_arch)) \
+ 	$($(target)_QT_PREFIX.$(bld_trg).$(bld_trg_arch)) \
+ 	$($(target)_QT_PREFIX.$(bld_trg_cpu)) \
+ 	$($(target)_QT_PREFIX.$(bld_type)) \
  	$($(target)_QT_PREFIX))
 ifeq ($(bld_trg),darwin)
@@ -835,9 +835,9 @@
 ifndef $(target)_QT_MOCSRCS
  $(foreach source, $(filter %.cxx %.CXX %.cpp %.CPP %.cc %.CC,\
- 	$($(target)_SOURCES.$(_bld_trg)) \
- 	$($(target)_SOURCES.$(_bld_trg_arch)) \
- 	$($(target)_SOURCES.$(_bld_trg).$(_bld_trg_arch)) \
- 	$($(target)_SOURCES.$(_bld_trg_cpu)) \
- 	$($(target)_SOURCES.$(_bld_type)) \
+ 	$($(target)_SOURCES.$(bld_trg)) \
+ 	$($(target)_SOURCES.$(bld_trg_arch)) \
+ 	$($(target)_SOURCES.$(bld_trg).$(bld_trg_arch)) \
+ 	$($(target)_SOURCES.$(bld_trg_cpu)) \
+ 	$($(target)_SOURCES.$(bld_type)) \
  	$($(target)_SOURCES) \
  	), $(evalval def_unit_qt4_target_pre_cpp_source))
@@ -861,9 +861,9 @@
 # Deal with QT_MOCSRCS.
 $(foreach source, \
-	$($(target)_QT_MOCSRCS.$(_bld_trg)) \
- 	$($(target)_QT_MOCSRCS.$(_bld_trg_arch)) \
- 	$($(target)_QT_MOCSRCS.$(_bld_trg).$(_bld_trg_arch)) \
- 	$($(target)_QT_MOCSRCS.$(_bld_trg_cpu)) \
- 	$($(target)_QT_MOCSRCS.$(_bld_type)) \
+	$($(target)_QT_MOCSRCS.$(bld_trg)) \
+ 	$($(target)_QT_MOCSRCS.$(bld_trg_arch)) \
+ 	$($(target)_QT_MOCSRCS.$(bld_trg).$(bld_trg_arch)) \
+ 	$($(target)_QT_MOCSRCS.$(bld_trg_cpu)) \
+ 	$($(target)_QT_MOCSRCS.$(bld_type)) \
  	$($(target)_QT_MOCSRCS) \
 	, $(evalvalctx def_unit_qt4_target_pre_handle_moc_src))
@@ -871,9 +871,9 @@
 # Deal with QT_MOCHDRS.
 $(foreach source, \
-	$($(target)_QT_MOCHDRS.$(_bld_trg)) \
- 	$($(target)_QT_MOCHDRS.$(_bld_trg_arch)) \
- 	$($(target)_QT_MOCHDRS.$(_bld_trg).$(_bld_trg_arch)) \
- 	$($(target)_QT_MOCHDRS.$(_bld_trg_cpu)) \
- 	$($(target)_QT_MOCHDRS.$(_bld_type)) \
+	$($(target)_QT_MOCHDRS.$(bld_trg)) \
+ 	$($(target)_QT_MOCHDRS.$(bld_trg_arch)) \
+ 	$($(target)_QT_MOCHDRS.$(bld_trg).$(bld_trg_arch)) \
+ 	$($(target)_QT_MOCHDRS.$(bld_trg_cpu)) \
+ 	$($(target)_QT_MOCHDRS.$(bld_type)) \
  	$($(target)_QT_MOCHDRS) \
 	, $(evalvalctx def_unit_qt4_target_pre_handle_moc_hdr))
@@ -882,9 +882,9 @@
 # ASSUMES (_ALL_)INSTALLS is processed after the targets using this unit.
 local translations := \
-	$($(target)_QT_TRANSLATIONS.$(_bld_trg)) \
- 	$($(target)_QT_TRANSLATIONS.$(_bld_trg_arch)) \
- 	$($(target)_QT_TRANSLATIONS.$(_bld_trg).$(_bld_trg_arch)) \
- 	$($(target)_QT_TRANSLATIONS.$(_bld_trg_cpu)) \
- 	$($(target)_QT_TRANSLATIONS.$(_bld_type)) \
+	$($(target)_QT_TRANSLATIONS.$(bld_trg)) \
+ 	$($(target)_QT_TRANSLATIONS.$(bld_trg_arch)) \
+ 	$($(target)_QT_TRANSLATIONS.$(bld_trg).$(bld_trg_arch)) \
+ 	$($(target)_QT_TRANSLATIONS.$(bld_trg_cpu)) \
+ 	$($(target)_QT_TRANSLATIONS.$(bld_type)) \
  	$($(target)_QT_TRANSLATIONS)
 ifneq ($(strip $(translations)),)